
XIncludeFile "Object.pb"


#Symbol_Epsilon = 256


Structure CharTable Extends Object
  Array eqclass.i(#Symbol_Epsilon)
  count.i
EndStructure


;##############################################################################################################
;##### CharTable #####

Procedure CharTableCompare(*this.CharTable, *other.CharTable)
  Protected cmp, i
  
  For i = 0 To #Symbol_Epsilon
    cmp = *this\eqclass(i) - *other\eqclass(i)
    If (cmp <> 0)
      ProcedureReturn cmp
    EndIf
  Next
  ProcedureReturn 0
EndProcedure


Declare NewCharTable()

Procedure CharTableCopy(*this.CharTable)
  Protected *other.CharTable, i
  
  *other = NewCharTable()
  For i = 0 To #Symbol_Epsilon
    *other\eqclass(i) = *this\eqclass(i)
  Next
  *other\count = *this\count
  
  ProcedureReturn *other
EndProcedure


Procedure CharTableFree(*this.CharTable)
  ClearStructure(*this, CharTable)
  FreeMemory(*this)
EndProcedure


Procedure NewCharTable()
  Protected *this.CharTable
  
  *this = AllocateMemory(SizeOf(CharTable))
  InitializeStructure(*this, CharTable)
  *this\free = @CharTableFree()
  *this\copy = @CharTableCopy()
  *this\compare = @CharTableCompare()
  *this\tostring = @StandardToStringFunction()
  
  *this\eqclass(#Symbol_Epsilon) = #Symbol_Epsilon
  
  ProcedureReturn *this
EndProcedure


; IDE Options = PureBasic 4.51 (Windows - x86)