EnableExplicit

Prototype FreeFunction(*this)
Prototype CopyFunction(*this)
Prototype CompareFunction(*this, *other)
Prototype.s ToStringFunction(*this)

Structure Object
  free.FreeFunction
  copy.CopyFunction
  compare.CompareFunction
  tostring.ToStringFunction
EndStructure

Macro FreeObject(__object__)
  __object__\free(__object__)
EndMacro

Macro CopyObject(__object__)
  __object__\copy(__object__)
EndMacro

Macro ToStringObject(__object__)
  __object__\tostring(__object__)
EndMacro


;##############################################################################################################
;##### Object #####

Procedure StandardFreeFunction(*this)
  FreeMemory(*this)
EndProcedure

Procedure StandardCopyFunction(*this)
  Protected size.i, *other
  
  size = MemorySize(*this)
  
  *other = AllocateMemory(size)
  CopyMemory(*this, *other, size)
  ProcedureReturn *other
EndProcedure

Procedure StandardCompareFunction(*this, *other)
  If (*this < *other)
    ProcedureReturn -1
  ElseIf (*this = *other)
    ProcedureReturn 0
  Else
    ProcedureReturn 1
  EndIf
EndProcedure

Procedure.s StandardToStringFunction(*this)
  ProcedureReturn Str(*this)
EndProcedure


Procedure MyDebug(string.s)
  Protected count, i
  
  count = CountString(string, Chr(10))
  For i = 0 To count
    Debug StringField(string,i+1,Chr(10))
  Next
EndProcedure


; IDE Options = PureBasic 4.51 (Windows - x86)