
XIncludeFile "Object.pb"


Structure Set Extends Object
  size.i
  Array *object.Object(7)
EndStructure


;##############################################################################################################
;##### Set #####

Procedure SetCompare(*this.Set, *other.Set)
  Protected cmp, i
  
  cmp = *this\size - *other\size
  If (cmp <> 0)
    ProcedureReturn cmp
  EndIf
  
  For i = 0 To *this\size - 1
    cmp = *this\object(i)\compare(*this\object(i), *other\object(i))
    If (cmp <> 0)
      ProcedureReturn cmp
    EndIf
  Next
  
  ProcedureReturn 0
EndProcedure


Declare NewSet()

Procedure SetCopy(*this.Set)
  Protected *copy.Set
  Protected i
  
  *copy = NewSet()
  ReDim *copy\object(ArraySize(*this\object()))
  
  For i = 0 To *this\size - 1
    *copy\object(i) = CopyObject(*this\object(i))
  Next
  *copy\size = *this\size
  
  ProcedureReturn *copy
EndProcedure


Procedure SetDelete(*this.Set, idx.i)
  *this\size - 1
  MoveMemory(@*this\object(idx+1), @*this\object(idx), SizeOf(Integer)*(*this\size - idx))
EndProcedure


Procedure SetClear(*this.Set)
  Protected i
  
  For i = 0 To *this\size - 1
    FreeObject(*this\object(i))
  Next
  *this\size = 0
EndProcedure


Procedure SetFree(*this.Set)
  SetClear(*this)
  ClearStructure(*this, Set)
  FreeMemory(*this)
EndProcedure


Procedure SetFreeNoDel(*this.Set)
  ClearStructure(*this, Set)
  FreeMemory(*this)
EndProcedure


Procedure.s SetToString(*this.Set)
  Protected string.s
  Protected i
  string = "{"
  
  For i = 0 To *this\size - 1
    If (i > 0)
      string + ", "
    EndIf
    string + ToStringObject(*this\object(i))
  Next
  
  string + "}"
  ProcedureReturn string
EndProcedure


Macro SetEnsure()
  If (*this\size + 1 > ArraySize(*this\object()))
    ReDim *this\object((*this\size + 1) * 2 - 1)
  EndIf
EndMacro


Procedure SetAddObject(*this.Set, *value.Object, *isadd.Byte=#Null)
  Protected cmp, left, right, middle
  
  left = -1
  right = *this\size
  
  While (left+1 < right)
    middle = (left+right) >> 1;/2
    cmp = *value\compare(*value, *this\object(middle))
    If (cmp = 0)
      If (*isadd <> #Null)
        *isadd\b = #False
      EndIf
      ProcedureReturn *this\object(middle)
      
    ElseIf (cmp < 0)
      right = middle
    Else
      left = middle
    EndIf
  Wend
  
  SetEnsure()
  If (right < *this\size)
    MoveMemory(@*this\object(right), @*this\object(right+1), SizeOf(Integer)*(*this\size - right))
  EndIf
  *this\object(right) = *value
  *this\size + 1
  If (*isadd <> #Null)
    *isadd\b = #True
  EndIf
  
  ProcedureReturn *value
EndProcedure


Procedure NewSet()
  Protected *this.Set
  
  *this = AllocateMemory(SizeOf(Set))
  InitializeStructure(*this, Set)
  *this\size = 0
  *this\free = @SetFree()
  *this\copy = @SetCopy()
  *this\compare = @SetCompare()
  *this\tostring = @SetToString()
  
  ProcedureReturn *this
EndProcedure

; 
; XIncludeFile "String.pb"
; 
; Define *set.Set, _fe_i
; *set = NewSet()
; SetAddObject(*set, NewStdString("a"))
; SetAddObject(*set, NewStdString("c"))
; SetAddObject(*set, NewStdString("d"))
; SetAddObject(*set, NewStdString("e"))
; SetAddObject(*set, NewStdString("f"))
; SetAddObject(*set, NewStdString("b"))
; SetAddObject(*set, NewStdString("f"))
; _fe_i = 3
; SetDelete(*set, i)
; SetAddObject(*set, NewStdString("g"))
; SetAddObject(*set, NewStdString("h"))
; SetAddObject(*set, NewStdString("i"))
; Debug ToStringObject(*set)
; ShowMemoryViewer(@*set\object(), SizeOf(Integer)*16)
; 


; IDE Options = PureBasic 4.60 (Windows - x86)