
XIncludeFile "Object.pb"


Structure Stack Extends Object
  List *object.Object()
EndStructure


;##############################################################################################################
;##### Stack #####

Procedure StackCompare(*this.Stack, *other.Stack)
  Protected cmp
  
  cmp = ListSize(*this\object()) - ListSize(*other\object())
  If (cmp <> 0)
    ProcedureReturn cmp
  EndIf
  
  ResetList(*other\object())
  ForEach *this\object()
    NextElement(*other\object())
    cmp = *this\object()\compare(*this\object(), *other\object())
    If (cmp <> 0)
      ProcedureReturn cmp
    EndIf
  Next
  
  ProcedureReturn 0
EndProcedure


Declare NewStack()
Declare StackPush(*this.Stack, *value.Object)

Procedure StackCopy(*this.Stack)
  Protected *copy.Stack
  
  *copy = NewStack()
  
  ForEach *this\object()
    AddElement(*copy\object())
    *copy\object() = CopyObject(*this\object())
  Next
  
  ProcedureReturn *copy
EndProcedure


Procedure StackClear(*this.Stack)
  ForEach *this\object()
    FreeObject(*this\object())
    DeleteElement(*this\object())
  Next
EndProcedure


Procedure StackFree(*this.Stack)
  StackClear(*this)
  ClearStructure(*this, Stack)
  FreeMemory(*this)
EndProcedure


Procedure.s StackToString(*this.Stack)
  Protected string.s
  string = "["
  
  ForEach *this\object()
    If (ListIndex(*this\object()) > 0)
      string + ", "
    EndIf
    string + ToStringObject(*this\object())
  Next
  
  string + "]"
  ProcedureReturn string
EndProcedure


Procedure StackPush(*this.Stack, *value.Object)
  LastElement(*this\object())
  AddElement(*this\object())
  *this\object() = *value
  
  ProcedureReturn #True
EndProcedure


Procedure StackPop(*this.Stack, delete=#True)
  Protected *result
  
  LastElement(*this\object())
  If (delete = #True)
    FreeObject(*this\object())
  Else
    *result = *this\object()
  EndIf
  DeleteElement(*this\object())
  
  ProcedureReturn *result
EndProcedure


Procedure StackPeek(*this.Stack)
  LastElement(*this\object())
  ProcedureReturn *this\object()
EndProcedure


Procedure StackIsEmpty(*this.Stack)
  If (ListSize(*this\object()) = 0)
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure


Procedure NewStack()
  Protected *this.Stack
  
  *this = AllocateMemory(SizeOf(Stack))
  InitializeStructure(*this, Stack)
  *this\free = @StackFree()
  *this\copy = @StackCopy()
  *this\compare = @StackCompare()
  *this\tostring = @StackToString()
  
  ProcedureReturn *this
EndProcedure


; IDE Options = PureBasic 4.51 (Windows - x86)
; EnableXP