
#FindMode_String = 1  ; ""
#FindMode_Bracket = 2 ; []
#FindMode_Parenth = 4 ; ()

Procedure FindStrMode(string.s, find.s, mode, position=0)
  Protected *start, *char.Character
  Protected instring = #False
  Protected incharst = #False
  
  *start = @string
  *char  = @string + position * SizeOf(Character)
  While (*char\c <> 0)
    
    If (instring = #False) And (incharst = #False)
      If (CompareMemoryString(*char, @find, 0, Len(find)) = #PB_String_Equal)
        ProcedureReturn (*char - *start) / SizeOf(Character) + 1
      EndIf
    EndIf
    
    If (mode & #FindMode_String)
      If (incharst = #False)
        If (*char\c = '"')
          instring = 1-instring
        EndIf
      EndIf
      If (instring = #False)
        If (*char\c = 39)
          incharst = 1-incharst
        EndIf
      EndIf
    EndIf
    
    *char + SizeOf(Character)
  Wend
  ProcedureReturn 0
EndProcedure


Procedure.s MyTrim(string.s)
  Protected pos
  
  pos = FindStrMode(string, ";", #FindMode_String)
  If (pos <> 0)
    string = Left(string, pos-1)
  EndIf
  string = Trim(string)
  
  ProcedureReturn string
EndProcedure


Procedure IsIgnoreChar(char.c)
  If (char = ' ') Or (char = 9)
    ProcedureReturn #True
  EndIf
EndProcedure

Procedure IsNameChar(char.c)
  If ((char >= 'a') And (char <= 'z')) Or ((char >= 'A') And (char <= 'Z')) Or (char = '_')
    ProcedureReturn #True
  EndIf
EndProcedure

Procedure IsNumberChar(char.c)
  If (char >= '0') And (char <= '9')
    ProcedureReturn #True
  EndIf
EndProcedure

Procedure CheckName(string.s)
  Protected *char.Character
  
  *char = @string
  While (*char\c <> 0)
    If (IsNameChar(*char\c))
    ElseIf (*char <> @string) And (IsNumberChar(*char\c))
    Else
      ProcedureReturn #False
    EndIf
    *char + SizeOf(Character)
  Wend
  ProcedureReturn #True
EndProcedure

Procedure.s StartWith(string.s)
  Protected *char.Character
  
  *char = @string
  
  If IsNameChar(*char\c) Or (*char\c = '%')
    *char + SizeOf(Character)
    While IsNameChar(*char\c)
      *char + SizeOf(Character)
    Wend
    ProcedureReturn Left(string, (*char-@string) / SizeOf(Character))
  EndIf
EndProcedure


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP