; Name: PBMakeTool (V.1.00)
; Author: Kevin Jasik (CSHW89)
; Date: 18.03.2012


#Version = 100


Global isOpenWin


Structure PosLength
  pos.i
  len.i
  string.s
EndStructure


Procedure GetParameter(*pl.PosLength)
  Protected *char.Character
  Protected isString
  
  *char = *pl\pos + *pl\len
  
  While (*char\c = ' ') Or (*char\c = 9)
    *char + SizeOf(Character)
  Wend
  
  *pl\pos = *char
  
  isString = #False
  While (*char\c <> 0)
    If (isString = #False)
      If (*char\c = ' ') Or (*char\c = 9)
        Break
      ElseIf (*char\c = '"')
        isString = #True
      EndIf
    Else
      If (*char\c = '"')
        isString = #False
      EndIf
    EndIf
    *char + SizeOf(Character)
  Wend
  
  *pl\len = *char - *pl\pos
  If (*pl\len = 0)
    ProcedureReturn #False
  EndIf
  
  *pl\string = PeekS(*pl\pos, *pl\len)
  If (Asc(Left(*pl\string,1)) = 34) And (Asc(Right(*pl\string,1)) = 34)
    *pl\string = Mid(*pl\string, 2, Len(*pl\string)-2)
  EndIf
  ProcedureReturn #True
EndProcedure


Procedure.s GetFileWithPath(file.s, path.s)
  If FindString(file, ":")
    ProcedureReturn file
  Else
    ProcedureReturn path+file
  EndIf
EndProcedure


Procedure OpenInfoWindow(dummy)
  OpenWindow(0, 0, 0, 404, 104, "PBMakeTool V."+StrF(#Version/100,2), #PB_Window_ScreenCentered)
  EditorGadget(0, 2, 2, 400, 100, #PB_Editor_ReadOnly)
  
  isOpenWin = #True
  
  Repeat
  Until (WaitWindowEvent() = #PB_Event_CloseWindow)
EndProcedure


Procedure AddStatusText(text.s)
  If (isOpenWin = #False)
    CreateThread(@OpenInfoWindow(), 0)
    Repeat: Until isOpenWin
  EndIf
  
  AddGadgetItem(0, -1, text)
EndProcedure


Procedure OpenMakeFile(startMode.s, path.s)
  Protected NewMap mode.i()
  
  Protected idx, runidx, i, cnt, first
  Protected indate, outdate, findoutput, run
  Protected pl.PosLength
  Protected string.s, key.s, file.s, params.s, runfile.s
  
  OpenPreferences(GetPathPart(ProgramFilename())+"PBMake.prefs")
  PreferenceGroup("Programs")
  
  idx = ReadFile(#PB_Any, path+"pbmake.txt")
  If (idx <> #Null)
    
    While (Eof(idx) = 0)
      
      string = Trim(ReadString(idx))
      
      If (string <> "")
        If (MapSize(mode()) = 0)
            
          cnt = CountString(string, ",")
          For i = 0 To cnt
            key = UCase(Trim(StringField(string, i+1, ",")))
            
            AddMapElement(mode(), key)
          Next
          
        Else
          If (string = ";")
            ClearMap(mode())
            
          ElseIf FindMapElement(mode(), startMode)
            pl\pos = @string
            pl\len = 0
            
            If GetParameter(pl)
              key = pl\string
              first = #True
              run = #False
              findoutput = #False
              
              While GetParameter(pl)
                
                If (Left(pl\string,1) <> "-")
                  file = GetFileWithPath(pl\string, path)
                  
                  If (first = #True)
                    If (FileSize(file) >= 0)
                      indate = GetFileDate(file, #PB_Date_Modified)
                    EndIf
                  Else
                    findoutput = #True
                    
                    If (FileSize(file) >= 0)
                      outdate = GetFileDate(file, #PB_Date_Modified)
                      
                      If (outdate <= indate)
                        run = #True
                        Break
                      EndIf
                      
                    Else
                      run = #True
                      Break
                    EndIf
                  EndIf
                EndIf
                
                first = #False
              Wend
              
              If (findoutput = #False)
                run = #True
              EndIf
              
              If (run = #True)
                params = Mid(string, Len(key)+1)
                
                runfile = ReadPreferenceString(key, "")
                runfile = GetFileWithPath(runfile, GetPathPart(ProgramFilename()))
                
                If (FileSize(runfile) >= 0)
                  AddStatusText("Run "+key+" "+params)
                  RunProgram(runfile, params, path, #PB_Program_Wait)
                Else
                  MessageRequester("PBMakeTool - Error", "Can't find the program "+key+":"+Chr(10)+runfile)
                EndIf
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
      
    Wend
    
    CloseFile(idx)
  EndIf
  
  ClosePreferences()
EndProcedure


Procedure main()
  Protected startMode.s, path.s
  
  startMode = ProgramParameter()
  path = ProgramParameter()
  
  OpenMakeFile(startMode, path)
EndProcedure


main()


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP
; Executable = PBMakeTool.exe
; CommandLine = BEFORE_COMP "D:\PureBasic-Programme\PBMakeTool\"