; Name: PBMakeToolInstaller (V.1.00)
; Author: Kevin Jasik (CSHW89)
; Date: 18.03.2012


Enumeration 
  #Gadget_InputTool
  #Gadget_DirectTool
  #Gadget_Install
  #Gadget_Uninstall
EndEnumeration


#Trigger_BeforeComp = 3
#Trigger_AfterComp = 4
#Trigger_BeforeExe = 6
#Trigger_AfterExe = 7

Global NewMap ToolKey.i()
ToolKey("BEFORE_COMP") = #Trigger_BeforeComp
ToolKey("AFTER_COMP")  = #Trigger_AfterComp
ToolKey("BEFORE_EXE")  = #Trigger_BeforeExe
ToolKey("AFTER_EXE")   = #Trigger_AfterExe


Procedure InstallPBMT(file.s)
  Protected i, cnt, find
  
  If OpenPreferences(file)
    If PreferenceGroup("ToolsInfo")
      ClosePreferences()
      CopyFile(file, file+".bak")
      OpenPreferences(file)
      PreferenceGroup("ToolsInfo")
      
      cnt = ReadPreferenceInteger("ToolCount", 0)
      
      ForEach ToolKey()
        find = 0
        For i = 0 To cnt - 1
          If PreferenceGroup("Tool_"+Str(i))
            If (ReadPreferenceString("MenuItemName", "") = "PBMakeTool "+MapKey(ToolKey()))
              find = #True
              Break
            EndIf
          EndIf
        Next
        
        If (find = #False)
          cnt + 1
          PreferenceGroup("ToolsInfo")
          WritePreferenceInteger("ToolCount", cnt)
          
          PreferenceGroup("Tool_"+Str(cnt-1))
          WritePreferenceString("Command", GetCurrentDirectory()+"PBMakeTool.exe")
          WritePreferenceString("Arguments", MapKey(ToolKey())+" "+Chr(34)+"%PATH"+Chr(34))
          WritePreferenceString("WorkingDir", "")
          WritePreferenceString("MenuItemName", "PBMakeTool "+MapKey(ToolKey()))
          WritePreferenceInteger("Shortcut", 0)
          WritePreferenceString("ConfigLine", "")
          WritePreferenceInteger("Trigger", ToolKey())
          WritePreferenceInteger("Flags", 1)
          WritePreferenceInteger("ReloadSource", 0)
          WritePreferenceInteger("HideEditor", 0)
          WritePreferenceInteger("HideFromMenu", 1)
          WritePreferenceInteger("SourceSpecific", 0)
          WritePreferenceInteger("Deactivate", 0)
        EndIf
      Next
      MessageRequester("PBMakeTool - Installer", "Successfully install!")
    Else
      MessageRequester("PBMakeTool - Installer", "File isn't the Tools.prefs:"+Chr(10)+file)
    EndIf
    ClosePreferences()
  Else
    MessageRequester("PBMakeTool - Installer", "Can't open the file:"+Chr(10)+file)
  EndIf
EndProcedure


Procedure UninstallPBMT(file.s)
  Protected i, cnt, remove
  Protected name.s, value.s
  Protected NewMap group.s()
  
  If OpenPreferences(file)
    If PreferenceGroup("ToolsInfo")
      ClosePreferences()
      CopyFile(file, file+".bak")
      OpenPreferences(file)
      PreferenceGroup("ToolsInfo")
      
      cnt = ReadPreferenceInteger("ToolCount", 0)
      
      For i = 0 To cnt - 1
        If PreferenceGroup("Tool_"+Str(i))
          name = ReadPreferenceString("MenuItemName", "")
          If (Left(name,11) = "PBMakeTool ") And FindMapElement(ToolKey(), Mid(name,12))
            
            RemovePreferenceGroup("Tool_"+Str(i))
            remove + 1
            
          Else
            If (remove > 0)
              ClearMap(group())
              If ExaminePreferenceKeys()
                While NextPreferenceKey()
                  group(PreferenceKeyName()) = PreferenceKeyValue()
                Wend
                PreferenceGroup("Tool_"+Str(i-remove))
                ForEach group()
                  WritePreferenceString(MapKey(group()), group())
                Next
                RemovePreferenceGroup("Tool_"+Str(i))
              EndIf
            EndIf
          EndIf
        EndIf
      Next
      
      cnt - remove
      PreferenceGroup("ToolsInfo")
      WritePreferenceInteger("ToolCount", cnt)
      
      MessageRequester("PBMakeTool - Installer", "Successfully uninstall!")
    Else
      MessageRequester("PBMakeTool - Installer", "File isn't the Tools.prefs:"+Chr(10)+file)
    EndIf
    ClosePreferences()
  Else
    MessageRequester("PBMakeTool - Installer", "Can't open the file:"+Chr(10)+file)
  EndIf
EndProcedure


Procedure MainWindow()
  Protected event, quit, egid
  Protected file.s
  
  If OpenWindow(0, 0, 0, 400, 85, "PBMakeTool - Installer", #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
    TextGadget(#PB_Any, 10, 13, 70, 15, "Tools.prefs:")
    StringGadget(#Gadget_InputTool,   80, 10, 270, 20, "")
    ButtonGadget(#Gadget_DirectTool, 360, 10,  30, 20, "...")
    ButtonGadget(#Gadget_Install,     10, 45, 185, 30, "Installiere PBMakeTool")
    ButtonGadget(#Gadget_Uninstall,  205, 45, 185, 30, "Deinstalliere PBMakeTool")
    
    CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Linux
      SetGadgetText(#Gadget_InputTool, GetEnvironmentVariable("HOME") + ".purebasic/tools.prefs")
    CompilerCase #PB_OS_MacOS
      SetGadgetText(#Gadget_InputTool, GetEnvironmentVariable("HOME") +"/.purebasic/tools.prefs")
    CompilerDefault
      SetGadgetText(#Gadget_InputTool, GetEnvironmentVariable("APPDATA") + "\purebasic\tools.prefs")
    CompilerEndSelect
        
    Repeat
      event = WaitWindowEvent()
      
      If (event = #PB_Event_Gadget)
        egid = EventGadget()
        
        Select egid
        Case #Gadget_DirectTool
          file = OpenFileRequester("Tools.prefs...", GetGadgetText(#Gadget_InputTool), "Preference-Datei (*.prefs)|*.prefs|Alle Dateien (*.*)|*.*", 0)
          If (file <> "")
            SetGadgetText(#Gadget_InputTool, file)
          EndIf
          
        Case #Gadget_Install
          InstallPBMT(GetGadgetText(#Gadget_InputTool))
          
        Case #Gadget_Uninstall
          UninstallPBMT(GetGadgetText(#Gadget_InputTool))
          
        EndSelect
      EndIf
      
      If (event = #PB_Event_CloseWindow)
        quit = #True
      EndIf
      
    Until quit
  EndIf
EndProcedure


MainWindow()


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP
; Executable = PBMakeToolInstaller.exe